<?php

interface DB
{
	public function execute($sql);
	public function query($sql);
	public function escape($sql);
	public function affected();
	public function insertId();
}

class MySQL_DB implements DB
{
	private $_id;
	public $prefix;

	public function __construct($host, $username, $password, $database, $prefix='', $names='utf8') {
		$this->connect($host, $username, $password, $database);
		$this->execute('SET NAMES "' . $this->escape($names) . '"');
		$this->prefix = $prefix;
	}

	public function execute($sql) {
		mysql_query($this->handleSql($sql), $this->_id);
		$this->checkErrors();
	}

	public function query($sql) {
		$result = mysql_query($this->handleSql($sql), $this->_id);
		$this->checkErrors();
		return new QueryResult($result);
	}

	public function escape($value) {
		return mysql_real_escape_string($value);
	}

	public function affected() {
		return mysql_affected_rows($this->_id);
	}

	public function insertId() {
		return mysql_insert_id($this->_id);
	}

	private function handleSql($sql) {
		return preg_replace_callback('#\{\{(.+?)\}\}#', function($matches) {
			return $this->prefix . $matches[1];
		}, $sql);
	}

	private function checkErrors() {
		if (mysql_errno($this->_id)) {
			throw new Exception(mysql_error());
		}
	}

	private function connect($host, $username, $password, $database) {
		if (!$this->_id = @mysql_connect($host, $username, $password))
			throw new Exception('Unable to connect to DB');
		if (!@mysql_select_db($database, $this->_id))
			throw new Exception('Unable to choose database');
	}
}

class QueryResult implements Iterator
{
	private $_result;
	private $_key = 0;

	public function __construct($result) {
		$this->_result = $result;
	}

	public function fetch() {
		return mysql_fetch_assoc($this->_result);
	}

	public function count() {
		return mysql_num_rows($this->_result);
	}

	public function current() {
		return $this->fetch();
	}

	public function next() {
		$this->_key++;
	}

	public function key() {
		return $this->_key;
	}

	public function valid() {
		return $this->_key < $this->count();
	}

	public function rewind() {
		if ($this->count()) {
			mysql_data_seek($this->_result, 0);
		}
		$this->_key = 0;
	}
}